<template>
    <div class="page-main-menu" @mouseleave="leaveCont">
        <div class="main-menu">
            <ul>
                <li 
                    v-for="(menu, key) in menus" 
                    :key="menu.txt" 
                    @mouseenter="mainMenuEnter(key)">
                        <a href="#" :class="{active: menu.active, 'active-hover': menu.hover}">{{menu.txt}}</a>
                </li>
            </ul>
        </div>
        <div class="sub-menu" :class="{'sub-menu-hover': subHover}">
            <div class="sub-menu-item" 
                v-for="(menu, key) in menus" 
                :key="key"
                :class="{'show-this':menu.subShow, 'show-this-hover':menu.subShowHover}">
                <ul>
                    <li v-for="(children, sKey) in menu.childrens" :key="sKey">
                        <router-link
                            :to="children.url" 
                            :class="{active: children.active}"
                            @click.native="subClick(key, sKey)">
                            {{children.txt}}
                        </router-link>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</template>
<script>
import $ from 'jquery';
import { setTimeout } from 'timers';
export default {
    data() {
        return {
            mainHover: false,
            subHover: false,
            menus:[
                {
                    txt: '首页',
                    url: '#',
                    active: true,   // 主导航是否激活
                    hover: false,   // 鼠标是否在主导航
                    subShow: true,  // 是否显示子导航
                    subShowHover:false, // 是否显示对应的子导航
                    childrens: [
                        {
                            txt: '状态显示',
                            url: '/home/state',
                            active: true
                        },
                        {
                            txt: '账户信息',
                            url: '/home/account',
                            active: false
                        },
                        {
                            txt: '修改密码',
                            url: '#',
                            active: false
                        }
                    ]
                },
                {
                    txt: '实时监控',
                    url: '#',
                    active: false,
                    hover: false,
                    subShow: false,
                    subShowHover: false,
                    childrens: [
                        {
                            txt: '过程监控',
                            url: '/monitor/process',
                            active: false
                        },
                        {
                            txt: '通道选择',
                            url: '/monitor/channnel',
                            active: false
                        },
                        {
                           txt: '信息显示',
                            url: '/monitor/info',
                            active: false 
                        }
                    ] 
                },
                {
                    txt: '检测试验',
                    url: '#',
                    active: false,
                    hover: false,
                    subShow: false,
                    subShowHover: false,
                    childrens: [
                        {
                            txt: '故障诊断',
                            url: '/testing/fault',
                            active: false
                        },
                        {
                            txt: '烤机试验',
                            url: '#',
                            active: false
                        }
                    ] 
                },
                {
                    txt: '数据分析',
                    url: '#',
                    active: false,
                    hover: false,
                    subShow: false,
                    subShowHover: false,
                    childrens: [
                        {
                            txt: '故障分析',
                            url: '#',
                            active: false
                        },
                        {
                            txt: '烤机分析',
                            url: '#',
                            active: false
                        },
                        {
                           txt: '统计分析',
                            url: '#',
                            active: false 
                        }
                    ] 
                },
                {
                    txt: '报表管理',
                    url: '#',
                    active: false,
                    hover: false,
                    subShow: false,
                    subShowHover: false,
                    childrens: [
                        {
                            txt: '报表生成',
                            url: '#',
                            active: false
                        },
                        {
                            txt: '报表下载',
                            url: '#',
                            active: false
                        }
                    ] 
                },
                {
                    txt: '信息管理',
                    url: '#',
                    active: false,
                    hover: false,
                    subShow: false,
                    subShowHover: false,
                    childrens: [
                        {
                            txt: '板卡管理',
                            url: '#',
                            active: false
                        },
                        {
                            txt: '测例管理',
                            url: '#',
                            active: false
                        },
                        {
                            txt: '资料管理',
                            url: '#',
                            active: false
                        }
                    ] 
                },
                {
                    txt: '系统管理',
                    url: '#',
                    active: false,
                    hover: false,
                    subShow: false,
                    subShowHover: false,
                    childrens: [
                        {
                            txt: '用户管理',
                            url: '#',
                            active: false
                        },
                        {
                            txt: '日志管理',
                            url: '#',
                            active: false
                        },
                        {
                            txt: '参数配置',
                            url: '#',
                            active: false
                        }
                    ] 
                },
            ]
        }
    },
    methods: {
        init: function() {
            // 遍历menu的值
            for(var i=0; i<this.menus.length; i++) {
                var menu = this.menus[i];
                menu.hover = false;
                menu.subShowHover= false;
                var childrens = menu.childrens;
                for(var k=0; k<childrens.length; k++){
                    var children = childrens[k];
                    children.hover = false;
                }
            }
        },
        initActive: function() {
            // 遍历menu的值
            for(var i=0; i<this.menus.length; i++) {
                var menu = this.menus[i];
                menu.active = false;
                menu.subShow = false;
                var childrens = menu.childrens;
                for(var k=0; k<childrens.length; k++){
                    var children = childrens[k];
                    children.active = false;
                }
            }
        },
        leaveCont: function() {
            this.mainHover = false;     // 容器
            this.subHover = false;      // 子导航
            this.init();
        },
        mainMenuEnter: function(index) {
            this.init();
            this.menus[index].hover = true;
            this.menus[index].subShowHover=true;
            this.subHover = true;      // 子导航
        },
        subClick: function(key, skey) {
            this.initActive();
            var menu = this.menus[key];
            var children = menu.childrens[skey];
            menu.subShow = true;
            menu.active = true;
            children.active = true;
        },
        setMenuState: function(path) {
            var key = 0;
            var skey = 0;
            // 遍历menu的值
            for(var i=0; i<this.menus.length; i++) {
                var menu = this.menus[i];
                var childrens = menu.childrens;
                for(var k=0; k<childrens.length; k++){
                    var children = childrens[k];
                    if(children.url != '#' && children.url == path) {
                        key = i;
                        skey = k;
                    }
                }
            }

            this.subClick(key, skey);
        }
    },
    mounted: function() {
        var path = this.$route.path;
        var store = this.$store;
        // 根据路由设置导航状态
        this.setMenuState(store.state.path);
    }
}
</script>
<style scoped>
    .main-menu {
        text-align: left;
        min-width: 1300px;
    }
    .main-menu ul {
        margin-left: 90px;
    }
    .main-menu li {
        display: inline-block;
    }
    .main-menu {
        padding-top: 8px;
    }
    .main-menu li a {
        display: block;
        text-align: center;
        font-size: 18px;
        min-width: 140px;
        margin-right: 20px;
        border-top-left-radius: 8px;
        border-top-right-radius: 8px;
        padding: 8px 20px;
    }
    .main-menu li a.active, .main-menu li a.active-hover{
        background-color: #0070C0;
        color: #FFFFFF;
    }
    .sub-menu {
        padding: 12px 0;
        background-color: #0070C0;
    }
    .sub-menu-item {
        display: none;
    }
    .sub-menu-hover .sub-menu-item.show-this{
        display: none;
    }
    .sub-menu.sub-menu-hover .sub-menu-item.show-this-hover {
        display: block;
    }
    .sub-menu-item.show-this{
        display: block;
    }
    .sub-menu-item ul {
        margin-left: 80px;
    }
    .sub-menu-item li {
        display: inline-flex;
    }
    .sub-menu-item li::before{
        content: '|';
        color: #FFFFFF;
        font-size: 20px;
        line-height: 32px;
    }
    .sub-menu-item li:first-child::before{
        content: '|';
        color: #0070C0;
        font-size: 18px;
        line-height: 32px;
    }
    .sub-menu-item li a {
        display: block;
        margin: 0 24px;
        font-size: 16px;
        padding: 4px 20px;
        color: #FFFFFF;
    }
    .sub-menu-item li a.active {
        border-radius: 16px;
        background-color: #FFFFFF;
        color: #2F89C9;
    }
    .sub-menu-item li a:hover {
        border-radius: 16px;
        background-color: #FFFFFF;
        color: #2F89C9;
    }
</style>
